﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RefactorPracticeCons.SwitchRefactor
{
    public abstract class EmployeeType_State
    {
        private const int ENGINEER = 1;
        private const int SALESMAN = 2;
        private const int MANAGER = 3;

        public static EmployeeType_State Create(int type)
        {
            EmployeeType_State empType = null;

            switch (type)
            {
                case ENGINEER:
                    empType = new EngineerType_State();
                    break;
                case SALESMAN:
                    empType = new SalesmanType_State();
                    break;
                case MANAGER:
                    empType = new ManagerType_State();
                    break;
            }

            return empType;
        }

        public abstract decimal getEmployeeSalary();
    }
}
